"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var stream_1 = require("stream");
var src_1 = require("../src");
var messages_1 = require("@cucumber/messages");
var assert_1 = __importDefault(require("assert"));
var package_json_1 = require("../package.json");
describe('jsonToMesssages', function () {
    it('emits a Source message for every Gherkin document', function () { return __awaiter(void 0, void 0, void 0, function () {
        var emitted;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, produceMessages([
                        JSON.stringify([
                            {
                                elements: [],
                                id: 'hooks',
                                keyword: 'Feature',
                                line: 1,
                                name: 'Hooks',
                                uri: 'features/hooks/hooks.feature',
                            },
                        ]),
                    ])];
                case 1:
                    emitted = _a.sent();
                    assert_1.default.equal(emitted.filter(function (envelope) { return envelope.source; }).length, 1);
                    return [2 /*return*/];
            }
        });
    }); });
    context('a meta Mesage is emitted at the beginning', function () {
        var meta;
        before(function () { return __awaiter(void 0, void 0, void 0, function () {
            var emitted;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, produceMessages(['[]'])];
                    case 1:
                        emitted = _a.sent();
                        meta = emitted.find(function (envelope) { return envelope.meta; }).meta;
                        return [2 /*return*/];
                }
            });
        }); });
        it('contains the @cucumber-messages version', function () {
            assert_1.default.equal(meta.protocolVersion, messages_1.version);
        });
        it('does not provide any information about the original producer of the JSON', function () {
            assert_1.default.equal(meta.implementation.name, '@cucumber/json-to-messages');
            assert_1.default.equal(meta.implementation.version, package_json_1.version);
        });
        it('doe not provide informations about the underlying infrastructure', function () {
            assert_1.default.equal(meta.cpu, null);
            assert_1.default.equal(meta.os, null);
            assert_1.default.equal(meta.runtime, null);
        });
    });
});
function produceMessages(jsons) {
    return __awaiter(this, void 0, void 0, function () {
        var inputStream, emitted, out;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    inputStream = new stream_1.Readable({
                        read: function () {
                            this.push(jsons.join(''));
                            this.push(null);
                        },
                    });
                    emitted = [];
                    out = new messages_1.NdjsonToMessageStream(messages_1.messages.Envelope.fromObject.bind(messages_1.messages.Envelope));
                    out.on('data', function (message) { return emitted.push(message); });
                    return [4 /*yield*/, src_1.jsonToMessages(inputStream, out)];
                case 1:
                    _a.sent();
                    return [2 /*return*/, emitted];
            }
        });
    });
}
//# sourceMappingURL=jsonToMessagesTest.js.map